// Copyright (c) 2015-present, salesforce.com, inc. All rights reserved
// Licensed under BSD 3-Clause - see LICENSE.txt or git.io/sfdc-license
const Kleisli = f => ({
  fold: f,
  concat: ({ fold: g }) => Kleisli(x => g(x).chain(f))
});

module.exports = Kleisli;
